clear all; close all;
%function [] = globecom_DF(bat_iter)
rand('state',41); rng('default');
load('data1.mat');
% BS_Power2 = BS_Power;
% delta2 = delta;
nUE = 10;
time = 2000;
E_max =  120*2;
index_cnt=1;
EBU1_1min = zeros(time,1);
for k=1:time
    EBU1_1min(k) =E_max*rand(1,1);
end
EBU1_PV_Output = EBU1_1min;
% unit of data is MB, distance is m
% for gamma = 0.5:0.75:1
P_min = 35;
P_max = 140;

c_effi = 0.8; % charging efficiency
s_effi = 0.99; % storage efficiency
bat_capacity = 3600*100; %100 WHr


UE_buffermax = 500*ones(nUE); %500M 

tx_power = 5.2;
noise = -105.86;
carrier_num = 12;
delta_max = 10; % the max buffer consumption rate is 10M

radius = 1000;%1km
grid = zeros(time,1); % grid power consumption
cost = zeros(time,1);
BS_Power = zeros(time,1);
utility = zeros(nUE,time);
delta = zeros(nUE,time);
UE_distance = 100*rand(nUE,1)+50*ones(nUE,1); % 50m
UE_SINR = zeros(nUE,carrier_num);
UE_avg_SINR = zeros(nUE,1);
UE_rate = zeros(nUE,1);
UE_buffer = zeros(nUE,time);
battery = zeros(time,1);

for nUE_loop = 1 :nUE % initialization
        UE_buffer(nUE_loop,1) = 10;
        for k = 1: carrier_num
            UE_SINR (nUE_loop,k) = 0;
            UE_rate (nUE_loop,k) = 0;
        end
        UE_avg_SINR(nUE_loop) = 10^(0.1*(tx_power - noise - 140.1 - 36.7 * log10(UE_distance(nUE_loop)/radius )));
end

for t = 1:time
    charge = 0; 
    discharge = 0;
% new user initializtion
    if t>1
        battery(t,:) = battery(t-1);         
    end

    

    for nUE_loop = 1 :nUE
         if t>1
            UE_buffer(nUE_loop,t) = UE_buffer(nUE_loop,t-1);
         end
            utility(nUE_loop,t) = log(1+mean_delta(nUE_loop));
        
        for k = 1: carrier_num

            UE_SINR (nUE_loop,k)  = exprnd(UE_avg_SINR(nUE_loop));
            UE_rate(nUE_loop,k) = log2(1+UE_SINR(nUE_loop,k))*10/12;
           % pathloss = 128.1 + 37.6 log10(R)dB (R [km])
        end
    end
     UE_buffer(:,t) =  UE_buffer(:,t) - mean_delta(:,1);
     UE_buffer(:,t)
% allocate user the best subcarrier id the buffer is not enough for playing
    active = zeros(carrier_num,1);
    [min_UE_buffer,index1] = min(UE_buffer(:,t));
    k = 1 ;
    while min_UE_buffer < 150 && k <  carrier_num+1
        [min_UE_buffer,index1] = min(UE_buffer(:,t));
        [sort_rate,index] = sort(UE_rate(index1,:),'descend');
          if active(index(k)) == 0;
             UE_buffer(index1,t) =   UE_buffer(index1,t)  + UE_rate(index1,index(k));
             active(index(k)) = 1;
             [min_UE_buffer,index1] = min(UE_buffer(:,t));
             k =1;
          else
             k =k+1;
          end
    end
 % calculate the power consumption
    UE_buffer(:,t)
BS_Power(t) = P_min + (P_max-P_min)*sum(active)/carrier_num;
if BS_Power(t) <EBU1_PV_Output(t)
    battery(t) = battery(t)*s_effi + (EBU1_PV_Output(t)-BS_Power(t))*c_effi;
    grid(t) = 0;
else  if battery(t) *s_effi > BS_Power(t) - EBU1_PV_Output(t)
        battery(t) = battery(t) *s_effi - BS_Power(t)+EBU1_PV_Output(t);
        grid(t) =0;
    else
        battery(t) = 0;    
        grid(t) = BS_Power(t) - EBU1_PV_Output(t)-battery(t)*s_effi ;
    end
    
end
cost(t) = grid(t) - sum(utility(:,t));
end

% 
% xlabel('Time Slot','FontSize',14,'fontWeight','bold')
% ylabel('UE Buffer Size (MB)','FontSize',14,'fontWeight','bold')
% axis([0 1200 -500 500])
% set(findall(fig, '-property', 'FontSize'), 'FontSize', 14, 'fontWeight', 'bold')
% 
% fig =figure
% box on
% hold on
% 
% plot (grid+EBU1_PV_Output,'b');
% plot (grid,'r');
% %axis([0 1200 0 100])
% xlabel('Time Slot','FontSize',14,'fontWeight','bold')
% ylabel('BS_Power(t) (WHr)','FontSize',14,'fontWeight','bold')
% legend('battery','FontSize',14,'fontWeight','bold')
% set(findall(fig, '-property', 'FontSize'), 'FontSize', 14, 'fontWeight', 'bold')
% 
% x=zeros(1,time);
% fig1 = figure
% box on
% plot(grid2);
% hold on
% plot(grid,'r');
% order=[2 1];
% plot(x,'--k');
% 
% xlabel('Time(Hr)','FontSize',14,'fontWeight','bold')
% ylabel('Surplus/Deficit Solar Power(W)')
% label= {'HTTP-D(battery)','our method'};
% legend(label);
% set(findall(fig1, '-property', 'FontSize'), 'FontSize', 14, 'fontWeight', 'bold')
% 
% fig3 = figure 
% hold on 
% plot( avg_buffer2);
% plot( sum(UE.buffer)'./act_num,'r');
% label= {'HTTP-D','SPAR'};
% legend(label)
% xlabel('Time(Hr)','FontSize',14)
% ylabel('Average Buffer(MB)')
% set(findall(fig3, '-property', 'FontSize'), 'FontSize', 14, 'fontWeight', 'bold')
% avg_buffer = sum(UE.buffer)'./act_num;
% % avg_buffer=avg_buffer(1201:30000);
% mean(BS_Power)
% mean(BS_Power2)
% mean(waste)
% mean(waste2)
% mean(grid)
% mean(grid2)
% mean(EBU1_PV_Output(1201:30000))
% 
% figure
% plot(battery_capacity)
% xlabel('Time(Hr)','FontSize',14,'fontWeight','bold')
% ylabel('Battery Capacity(Wh)')
% save('nondash.mat','BS_Power','delta','grid','avg_buffer');
% 
greedy_buffer_max= max(max(UE_buffer))
greedy_battery_max = max(battery)
greedy_buffer = mean(mean(UE_buffer,2));
grid = mean(grid)
BSpower = mean(BS_Power)
greedy_battery = mean(battery);
plot(UE_buffer(6,:))
save('greedy.mat','greedy_battery' ,'greedy_buffer','greedy_buffer_max','greedy_battery_max')
%  mean(BS_Power)