clear all; close all;
%function [] = globecom_DF(bat_iter)
rand('state',41); rng('default');
load('data1.mat');
% BS_Power2 = BS_Power;
% delta2 = delta;
nUE = 10;
time = 1200;
load('Solar.mat');

E_max = 200;
index_cnt=1;
for k=1:time
    EBU1_1min(k) =E_max*rand(1,1);
end
EBU1_PV_Output = EBU1_1min;



for iter =9
% for gamma = 0.5:0.75:1
P_min = 35;
P_max = 140;

c_effi = 0.9; % charging efficiency
s_effi = 0.99; % storage efficiency

bat_capacity = 250

UE_buffermax = 500*ones(nUE); %500M 

macro_power = 5;
noise = -105.86;
carrier_num = 20;
delta_max = 10; % the max buffer consumption rate is 10M

radius = 1000;%1km
grid = zeros(time,1); % grid power consumption
cost = zeros(time,1);
BS_Power = zeros(time,1);
utility = zeros(nUE,time);
delta = zeros(nUE,time);
UE_distance = 50*rand(nUE,1)+50*ones(nUE,1); % 50m
UE_SINR = zeros(nUE,carrier_num);
UE_avg_SINR = zeros(nUE,1);
UE_rate = zeros(nUE,1);
UE_buffer = zeros(nUE,time);
battery = zeros(time,1);

for nUE_loop = 1 :nUE % initialization
        UE_buffer(nUE_loop,1) = 100;
        for k = 1: carrier_num
            UE_SINR (nUE_loop,k) = 0;
            UE_rate (nUE_loop,k) = 0;
        end
        UE_avg_SINR(nUE_loop) = 10^(0.1*(macro_power - noise - 140.1 - 36.7 * log10(UE_distance(nUE_loop)/radius )));
end

for t = 1:time
    charge = 0; 
    discharge = 0;
% new user initializtion
    if t>1
        battery(t,:) = battery(t-1);         
    end

    

    for nUE_loop = 1 :nUE
         if t>1
            UE_buffer(nUE_loop,t) = UE_buffer(nUE_loop,t-1);
         end
            if UE_buffer(nUE_loop,t) < 10
                detla(nUE_loop,t) = 0;
            else
                detla(nUE_loop,t) =  min(UE_buffer(nUE_loop,t)-4,10);
            end
                utility(nUE_loop,t) =log(1+detla(nUE_loop,t));
        
        for k = 1: carrier_num

            UE_SINR (nUE_loop,k)  = exprnd(UE_avg_SINR(nUE_loop));
            UE_rate(nUE_loop,k) = log2(1+UE_SINR(nUE_loop,k))*10/20;
           % pathloss = 128.1 + 37.6 log10(R)dB (R [km])
        end
    end
     UE_buffer(:,t) =  UE_buffer(:,t) - detla(:,t);

% allocate user the best subcarrier id the buffer is not enough for playing
    active = zeros(carrier_num,1);
    [min_UE_buffer,index1] = min(UE_buffer(:,t));
    k = 1 ;
    while  min_UE_buffer < 50 &&k <  carrier_num+1
        [min_UE_buffer,index1] = min(UE_buffer(:,t));
        [sort_rate,index] = sort(UE_rate(index1,:),'descend');
          if active(index(k)) == 0;
             UE_buffer(index1,t) =   UE_buffer(index1,t)  + UE_rate(index1,index(k));
             active(index(k)) = 1;
             [min_UE_buffer,index1] = min(UE_buffer(:,t));
             k =1;
          else
             k =k+1;
          end
    end
 % calculate the power consumption
BS_Power(t) = P_min + (P_max-P_min)*sum(active)/carrier_num;
if BS_Power(t) <EBU1_PV_Output(t)
    battery(t) = min(battery(t)*s_effi + (EBU1_PV_Output(t)-BS_Power(t))*c_effi,bat_capacity );
    grid(t) = 0;
else  if battery(t) *s_effi > BS_Power(t) - EBU1_PV_Output(t)
        battery(t) = battery(t) *s_effi - BS_Power(t)+EBU1_PV_Output(t);
        grid(t) =0;
    else
        battery(t) = 0;    
        grid(t) = BS_Power(t) - EBU1_PV_Output(t)-battery(t)*s_effi ;
    end
    
end
cost(t) = grid(t) - sum(utility(:,t));
end


greedy_buffer_max= max(max(UE_buffer))
greedy_battery_max = max(battery)
greedy_buffer = mean(mean(UE_buffer,2));
grid = mean(grid)
BSpower = mean(BS_Power)
greedy_battery = mean(battery);
greedy_cost = mean(cost)
plot(UE_buffer(2,:))
save('greedy.mat','greedy_battery' ,'greedy_buffer','greedy_buffer_max','greedy_battery_max','greedy_cost')
%  mean(BS_Power)
end