clear all; close all;
%function [] = globecom_DF(bat_iter)
rand('state',41); rng('default');
load('data1.mat');
load('spar.mat');
load('greedy.mat');
% BS_Power2 = BS_Power;
% delta2 = delta;
nUE = 10;
time = 1200;
E_max = 200;
index_cnt=1;
for k=1:time
    EBU1_1min(k) =E_max*rand(1,1);
end
EBU1_PV_Output = EBU1_1min;
% unit of data is MB, distance is m
% for gamma = 0.5:0.75:1
UE_distance = 100*rand(nUE,1)+50*ones(nUE,1); % 50m
for iter = 1:9
P_min = 35;
P_max = 140;
user_weight = 1;
c_effi = 0.8; % charging efficiency
s_effi = 0.99; % storage efficiency

bat_capacity = 250; %100 WHr
penalty = 30*iter;
theta_bat = penalty + P_max;

UE_buffermax = 500*ones(nUE); %500M 

macro_power = 5.2;
noise = -105.86;
carrier_num = 20;
delta_max = 10; % the max buffer consumption rate is 10M
UE_theta = user_weight*penalty + delta_max;

radius = 1000;%1km
grid_ = zeros(time,1); % grid power consumption
discharge = zeros(time,1);
cost = zeros(time,1);
BS_Power = zeros(time,1);
utility = zeros(nUE,time);
delta = zeros(nUE,time);

UE_SINR = zeros(nUE,carrier_num);
UE_avg_SINR = zeros(nUE,1);
UE_rate = zeros(nUE,1);
UE_buffer = zeros(nUE,time);
battery = zeros(time,1);

for nUE_loop = 1 :nUE % initialization
        UE_buffer(nUE_loop,1) = 10;
        for k = 1: carrier_num
            UE_SINR (nUE_loop,k) = 0;
            UE_rate (nUE_loop,k) = 0;
        end
        UE_avg_SINR(nUE_loop) = 10^(0.1*(macro_power - noise - 140.1 - 36.7 * log10(UE_distance(nUE_loop)/radius )));
end

for t = 1:time
    charge = 0; 

    if t>1
        battery(t,:) = battery(t-1);         
    end
    battery_queue = battery(t) - theta_bat;
    

    for nUE_loop = 1 :nUE
         if t>1
            UE_buffer(nUE_loop,t) = UE_buffer(nUE_loop,t-1);
         end
        utility(nUE_loop,t) = log(1+mean_delta(nUE_loop,iter));
        for k = 1: carrier_num

            UE_SINR (nUE_loop,k)  = exprnd(UE_avg_SINR(nUE_loop));
            UE_rate(nUE_loop,k) = log2(1+UE_SINR(nUE_loop,k))*10.5/carrier_num;
           % pathloss = 128.1 + 37.6 log10(R)dB (R [km])
        end
    end
    % UE_buffer_queue = UE_buffer(:,t) - UE_theta*ones(nUE,1);

%charge/discharge decision
     use_bat = 1; 
     if  battery_queue >= -penalty
         use_bat = 1;
     else
         use_bat = -1;    
     end

% decide buffer consumption rate
       
     
%     for nUE_loop = 1 :nUE
%         if UE_buffer_queue(nUE_loop) <= -user_weight*penalty/(1+delta_max)
%             delta(nUE_loop,t)= -user_weight*penalty/UE_buffer_queue(nUE_loop)-1;
%             utility(nUE_loop,t) = log(1+delta(nUE_loop,t));
%         else
%             delta(nUE_loop,t) = delta_max;
%             utility(nUE_loop,t) = log(1+delta(nUE_loop,t));
%         end
%     end
% subcarrier allocation
    active = zeros(carrier_num,1);   
    [sort_buffer,index_buf] = sort(UE_buffer(:,t),'ascend');

    for nUE_loop = 1 :nUE
        if UE_buffer(index_buf(nUE_loop),t) > 200 + penalty
            continue;
        end
        [sort_rate,index_sub] = sort(UE_rate(index_buf(nUE_loop),:),'descend');
        req_rate = 0;
        for k = 1: carrier_num
            if active(index_sub(k)) == 0 && req_rate < mean_delta(index_buf(nUE_loop),iter)
                active(index_sub(k)) = 1; 
                req_rate = req_rate + UE_rate(index_buf(nUE_loop),index_sub(k));
                UE_buffer(index_buf(nUE_loop),t) = UE_buffer(index_buf(nUE_loop),t) + UE_rate(index_buf(nUE_loop),index_sub(k));
            end
        end
    end
%     if use_bat ==1;
%         threshold = 10.5*battery_queue/carrier_num;
%     else
%         threshold = -10.5*penalty/carrier_num;
%     end
%    for k = 1: carrier_num
%     UE_rate_queue(:,k) = UE_rate(:,k).*UE_buffer_queue;
%    end
%     [sort_rate,index] = sort(UE_buffer_queue,'aescend'); 
% 
%     for k = 1: carrier_num
%         if min_rate_queue(k) < threshold
%             active_num  = active_num +1;
%            
%             UE_buffer(index(k),t) = UE_buffer(index(k),t) + UE_rate(index(k),k);
%           
%         end
%     end
%     active = zeros(carrier_num,1);   
%     [min_UE_buffer,index1] = min(UE_buffer(:,t));
%     k = 1 ;
%     while   k <  carrier_num+1
%         [min_UE_buffer,index1] = min(UE_buffer(:,t));
%         [sort_rate,index] = sort(UE_rate(index1,:),'descend');
%           if active(index(k)) == 0;
%              UE_buffer(index1,t) =   UE_buffer(index1,t)  + UE_rate(index1,index(k));
%              active(index(k)) = 1;
%              [min_UE_buffer,index1] = min(UE_buffer(:,t));
%              k =1;
%           else
%              k =k+1;
%           end
%     end
% update the buffer with consumption 

%     UE_buffer(:,t) = UE_buffer(:,t) - delta(:,t);
    UE_buffer(:,t) =  UE_buffer(:,t) - mean_delta(:,iter);
 % calculate the power consumption
    
BS_Power(t) = P_min + (P_max-P_min)*sum(active)/carrier_num;
switch use_bat
    case 1
        battery(t) = battery(t)*s_effi - max(BS_Power(t)-EBU1_PV_Output(t),0) ;
        grid_(t) =0;

    case -1
        battery(t) = min(battery(t) *s_effi + EBU1_PV_Output(t)*c_effi,bat_capacity); 
        grid_(t) =BS_Power(t);
end
cost(t) = grid_(t) -user_weight* sum(utility(:,t));
agg_util = sum(utility(:,t));
end







buffer_perf_max(iter) = max(max(UE_buffer));
battery_perf_max(iter) = max(battery);
buffer_perf(iter) =mean(mean(UE_buffer,2));
cost_perf(iter)=mean(cost)
util_perf(iter)=mean(agg_util)
grid_perf(iter)=mean(grid_)
battery_perf(iter)=mean(battery)


cost_greedy(iter) = greedy_cost ;
battery_greedy(iter) = greedy_battery;
buffer_greedy(iter) = greedy_buffer;
buffer_greedy_max(iter) = greedy_buffer_max;
battery_greedy_max(iter) = greedy_battery_max;
end
buffer_perf_max(iter) = max(max(UE_buffer))
battery_perf_max(iter) = max(battery)
buffer_perf(iter) =mean(mean(UE_buffer,2))
cost_perf(iter)=mean(cost)
util_perf(iter)=mean(agg_util)
grid_perf(iter)=mean(grid_)
battery_perf(iter)=mean(battery)

fig =figure
box on;
hold on;

plot(cost_greedy,'-b*','linewidth',2);
plot (cost_perf,'-g+','linewidth',2);
plot (cost_spar,'-ro','linewidth',2);
xlabel('V','FontSize',14,'fontWeight','bold')

legend('Greedy-MP','LPB','L-SPAR','FontSize')

set(findall(fig, '-property', 'FontSize'), 'FontSize', 14,'fontWeight','bold')
ylabel('Weighted Sum of Energy Consumption and Utility','FontSize',12,'fontWeight','bold')
set(gca,'XTick',1:9)
set(gca,'XTickLabel',{'30','60','90','120','150','180','210','240','270'})
print Vdmeta;
print (fig,'-dmeta','-painters','-r864','dataFigure');
fig_name = 'Network_versus_V';
saveas(gcf, fig_name,'emf');
saveas(gcf, fig_name, 'fig');



fig =figure
box on;

hold on
plot (util_spar,'-g+','linewidth',2);
plot (util_spar,'-ro','linewidth',2);
xlabel('V','FontSize',14,'fontWeight','bold')
ylabel('Aggregate Utility','FontSize',14,'fontWeight','bold')
legend('LPB','L-SPAR','FontSize')
axis([1 8 0 25])
set(findall(fig, '-property', 'FontSize'), 'FontSize', 14,'fontWeight','bold')
set(gca,'XTick',1:9)
set(gca,'XTickLabel',{'30','60','90','120','150','180','210','240','270'})
print Vdmeta;
print (fig,'-dmeta','-painters','-r864','dataFigure');
fig_name = 'utility_versus_V';
saveas(gcf, fig_name, 'emf');
saveas(gcf, fig_name, 'fig');

fig =figure
box on
hold on

plot (grid_perf,'-g+','linewidth',2);
plot (grid_spar,'-ro','linewidth',2);
xlabel('V','FontSize',14,'fontWeight','bold')
ylabel('Average Grid Power Consumption(W)','FontSize',14,'fontWeight','bold')
legend('LPB','L-SPAR')
axis([1 8 0 80])
set(findall(fig, '-property', 'FontSize'), 'FontSize', 14,'fontWeight','bold')
set(gca,'XTick',1:9)
set(gca,'XTickLabel',{'30','60','90','120','150','180','210','240','270'})
print Vdmeta;
print (fig,'-dmeta','-painters','-r864','dataFigure');
fig_name = 'energy_versus_V';
saveas(gcf, fig_name, 'emf');
saveas(gcf, fig_name, 'fig');

fig =figure
box on
hold on

plot(battery_greedy_max,'-b*','linewidth',2);
plot (battery_perf_max,'-g+','linewidth',2);
plot (battery_spar_max,'-ro','linewidth',2);
xlabel('V','FontSize',14)
ylabel('Required Battery(J)','FontSize',14,'fontWeight','bold')
legend('Greedy-MP','LPB','L-SPAR')
axis([1 8 0 400])
set(findall(fig, '-property', 'FontSize'), 'FontSize', 14,'fontWeight','bold')
set(gca,'XTick',1:9)
set(gca,'XTickLabel',{'30','60','90','120','150','180','210','240','270'})
print Vdmeta;
print (fig,'-dmeta','-painters','-r864','dataFigure');
fig_name = 'Max Bat_versus_V';
saveas(gcf, fig_name, 'emf');
saveas(gcf, fig_name, 'fig');


fig =figure
box on
hold on

plot(buffer_greedy_max,'-b*','linewidth',2);
plot (buffer_perf,'-g+','linewidth',2);
plot (buffer_spar_max,'-ro','linewidth',2);
xlabel('V','FontSize',14,'fontWeight','bold')
ylabel('Required Buffer(MB)','FontSize',14,'fontWeight','bold')
legend('Greedy-MP','LPB','L-SPAR','FontSize')

set(findall(fig, '-property', 'FontSize'), 'FontSize', 14,'fontWeight','bold')
set(gca,'XTick',1:9)
set(gca,'XTickLabel',{'30','60','90','120','150','180','210','240','270'})
print Vdmeta;

print (fig,'-dmeta','-painters','-r864','dataFigure');
fig_name = 'max_buffer_versus_V';
saveas(gcf, fig_name, 'emf');
saveas(gcf, fig_name, 'fig');

%  mean(BS_Power)