fig =figure
box on
hold on

x = [1 1.83 2 3 4 5 6 7]
grid_greedy = [27.3344 25.52 25.4145 24.5087 24.2256 24.0942 23.8304 23.80]
grid_spar = [26.7409 23.80 21.4790 16.7171 14.5788   14.6413 14.5508 14.50]
g=[23.8 23.8 23.8 23.8 23.8 23.8 23.8 23.8];
SP=1.83; %your point goes here 

plot (x,grid_greedy,'-b+','linewidth',2);
plot (x,grid_spar,'-ro','linewidth',2);
plot(g,'--k');

ylegend = {'Greedy-MP','L-SPAR'}
xlabel('Battery Size (J)','FontSize',14,'fontWeight','bold')
ylabel('Average Grid Power Consumption (W)','FontSize',14,'fontWeight','bold')
legend(ylegend,'FontSize',14,'fontWeight','bold')
axis([1 7 10 35])
set(findall(fig, '-property', 'FontSize'), 'FontSize', 14,'fontWeight','bold')
set(gca,'XTick',[1 1.8 2 3 4 5 6 7])
set(gca,'XTickLabel',{'100','141.5','150','200','250','300', '350', '400' })
print Vdmeta;
print (fig,'-dmeta','-painters','-r864','dataFigure');
fig_name = 'energy_versus_V';
saveas(gcf, fig_name, 'emf');
saveas(gcf, fig_name, 'fig');
