clear all; close all;
%function [] = globecom_DF(bat_iter)
rand('state',41); rng('default');

% BS_Power2 = BS_Power;
% delta2 = delta;

nUE = 10;
time = 1200;
E_max = 80*2;
index_cnt=1;
for k=1:time
    EBU1_1min(k) =E_max*rand(1,1);
end
EBU1_PV_Output = EBU1_1min;
% unit of data is MB, distance is m
% for gamma = 0.5:0.75:1
UE_distance = 100*rand(nUE,1)+50*ones(nUE,1); % 50m


% for plot
battery_spar = zeros(time,2);
UE1_buffer_spar = zeros(time,2);
UE2_buffer_spar = zeros(time,2);
UE1_delta = zeros(time,2);
UE2_delta = zeros(time,2);

%
for iter = 1:2
P_min = 35;
P_max = 140;
user_weight = 1;
c_effi = 0.8; % charging efficiency
s_effi = 0.99; % storage efficiency
bat_capacity = 3600*100; %100 WHr
penalty = 75*iter;
theta_bat = penalty + P_max/s_effi;

UE_buffermax = 500*ones(nUE); %500M 

macro_power = 5.2;
noise = -105.86;
carrier_num = 12;
delta_max = 10; % the max buffer consumption rate is 10M
UE_theta = user_weight*penalty + delta_max;

radius = 1000;%1km
grid_ = zeros(time,1); % grid power consumption
discharge = zeros(time,1);
cost = zeros(time,1);
BS_Power = zeros(time,1);
utility = zeros(nUE,time);
delta = zeros(nUE,time);

UE_SINR = zeros(nUE,carrier_num);
UE_avg_SINR = zeros(nUE,1);
UE_rate = zeros(nUE,1);
UE_buffer = zeros(nUE,time);
battery = zeros(time,1);

for nUE_loop = 1 :nUE % initialization
        UE_buffer(nUE_loop,1) = 10;
        for k = 1: carrier_num
            UE_SINR (nUE_loop,k) = 0;
            UE_rate (nUE_loop,k) = 0;
        end
        UE_avg_SINR(nUE_loop) = 10^(0.1*(macro_power - noise - 140.1 - 36.7 * log10(UE_distance(nUE_loop)/radius )));
end

for t = 1:time
    charge = 0; 

% new user initializtion
    if t>1
        battery(t,:) = battery(t-1);         
    end
    battery_queue = battery(t) - theta_bat;
    

    for nUE_loop = 1 :nUE
         if t>1
            UE_buffer(nUE_loop,t) = UE_buffer(nUE_loop,t-1);
         end

        for k = 1: carrier_num

            UE_SINR (nUE_loop,k)  = exprnd(UE_avg_SINR(nUE_loop));
            UE_rate(nUE_loop,k) = log2(1+UE_SINR(nUE_loop,k))*10/12;
           % pathloss = 128.1 + 37.6 log10(R)dB (R [km])
        end
    end
     UE_buffer_queue = UE_buffer(:,t) - UE_theta*ones(nUE,1);

%charge/discharge decision
     use_bat = 1; 
     if  battery_queue >= -penalty/c_effi
            use_bat = 1;
     
        if battery_queue <= -penalty 
            use_bat = 0;        
        end
     else

         use_bat = -1;    
     end
     
% decide buffer consumption rate
    for nUE_loop = 1 :nUE
        if UE_buffer_queue(nUE_loop) <= -user_weight*penalty/(1+delta_max)
            delta(nUE_loop,t)= -user_weight*penalty/UE_buffer_queue(nUE_loop)-1;
            utility(nUE_loop,t) = log(1+delta(nUE_loop,t));
        else
            delta(nUE_loop,t) = delta_max;
            utility(nUE_loop,t) = log(1+delta(nUE_loop,t));
        end
    end
% subcarrier allocation
    if use_bat ==1;
        threshold = 10.5*battery_queue/12;
    else
        threshold = -10.5*penalty/12;
    end
   for k = 1: carrier_num
    UE_rate_queue(:,k) = UE_rate(:,k).*UE_buffer_queue;

   end
     [min_rate_queue,index] = min(UE_rate_queue);
    active_num =0;
    for k = 1: carrier_num
        if min_rate_queue(k) < threshold
            active_num  = active_num +1;
           
            UE_buffer(index(k),t) = UE_buffer(index(k),t) + UE_rate(index(k),k);
          
        end
    end
% update the buffer with consumption 

    UE_buffer(:,t) = UE_buffer(:,t) - delta(:,t);

 % calculate the power consumption
    
BS_Power(t) = P_min + (P_max-P_min)*active_num/carrier_num;
switch use_bat
    case 1
        battery(t) = battery(t)*s_effi - max(BS_Power(t)-EBU1_PV_Output(t),0) ;
       
        grid_(t) =0;
    case 0 
        battery(t) = battery(t) *s_effi +max(0,EBU1_PV_Output(t)-BS_Power(t));
        grid_(t) =max(0,BS_Power(t) - EBU1_PV_Output(t));
    case -1
        battery(t) = battery(t) *s_effi + EBU1_PV_Output(t)*c_effi ;
        grid_(t) =BS_Power(t);
end
cost(t) = grid_(t) -user_weight* sum(utility(:,t));
end



% x=zeros(1,time);
% fig1 = figure
% box on
% plot(grid2);
% hold on
% plot(grid,'r');
% order=[2 1];
% plot(x,'--k');
% 
% xlabel('Time(Hr)','FontSize',14,'fontWeight','bold')
% ylabel('Surplus/Deficit Solar Power(W)')
% label= {'HTTP-D(battery)','our method'};
% legend(label);
% set(findall(fig1, '-property', 'FontSize'), 'FontSize', 14, 'fontWeight', 'bold')
% 
% fig3 = figure 
% hold on 
% plot( avg_buffer2);
% plot( sum(UE.buffer)'./act_num,'r');
% label= {'HTTP-D','SPAR'};
% legend(label)
% xlabel('Time(Hr)','FontSize',14)
% ylabel('Average Buffer(MB)')
% set(findall(fig3, '-property', 'FontSize'), 'FontSize', 14, 'fontWeight', 'bold')
% avg_buffer = sum(UE.buffer)'./act_num;
% % avg_buffer=avg_buffer(1201:30000);
% mean(BS_Power)
% mean(BS_Power2)
% mean(waste)
% mean(waste2)
% mean(grid)
% mean(grid2)
% mean(EBU1_PV_Output(1201:30000))
% 
% figure
% plot(battery_capacity)
% xlabel('Time(Hr)','FontSize',14,'fontWeight','bold')
% ylabel('Battery Capacity(Wh)')



mean_delta = mean (delta,2)

cost_spar(iter) = mean(cost);
battery_spar(:,iter) = battery;
UE1_buffer_spar(:,iter) = UE_buffer(1,:);
UE2_buffer_spar(:,iter) = UE_buffer(7,:);
UE1_delta(:,iter) = delta(1,:);
UE2_delta(:,iter) = delta(7,:);
mean(grid_)


end
x=250*ones(1,time);
fig =figure
box on
hold on


plot (UE1_buffer_spar(:,1),'b','linewidth',2);
plot (UE2_buffer_spar(:,1),'r','linewidth',2);
plot (UE1_buffer_spar(:,2),'c','linewidth',2);
plot (UE2_buffer_spar(:,2),'m','linewidth',2);

plot(x,'--k','linewidth',2);
xlabel('Time (Sec)','FontSize',14,'fontWeight','bold')
ylabel('UE Buffer Level (MB)','FontSize',14,'fontWeight','bold')
label= {'UE1(V=75)','UE2(V=75)','UE1(V=150)','UE2(V=150)'};
legend(label,'FontSize',14,'fontWeight','bold')
axis([0 500 0 300])
set(findall(fig, '-property', 'FontSize'), 'FontSize', 14, 'fontWeight', 'bold')
fig_name = 'buffer vs time';
saveas(gcf, fig_name, 'emf');
saveas(gcf, fig_name, 'fig');

x=300*ones(1,time);
fig =figure
box on
hold on

plot (battery_spar(:,1),'b','linewidth',2);
plot (battery_spar(:,2),'r','linewidth',2);
plot(x,'--k','linewidth',2);
axis([0 500 0 400])
xlabel('Time (Sec)','FontSize',14,'fontWeight','bold')
ylabel('Battery Level (J)','FontSize',14,'fontWeight','bold')
label= {'Battery (V=75)','Battery (V=150)'};
legend(label,'FontSize',14,'fontWeight','bold')
fig_name = 'battery vs time';

set(findall(fig, '-property', 'FontSize'), 'FontSize', 14, 'fontWeight', 'bold')
saveas(gcf, fig_name, 'emf');
saveas(gcf, fig_name, 'fig');
fig =figure
box on
hold on

plot (UE1_delta(:,1),'b','linewidth',2);
plot (UE1_delta(:,2),'r','linewidth',2);
axis([0 500 0 10])
xlabel('Time (Sec)','FontSize',12,'fontWeight','bold')
ylabel('Buffer Consumption Rate (MB/s)','FontSize',12,'fontWeight','bold')
legend('V=75','V=150','FontSize',12,'fontWeight','bold')
set(findall(fig, '-property', 'FontSize'), 'FontSize', 12, 'fontWeight', 'bold')


