clear all; close all;
%function [] = globecom_DF(bat_iter)
rand('state',41); rng('default');

% BS_Power2 = BS_Power;
% delta2 = delta;
load('Solar.mat');
nUE = 10;
time = 30000;
E_max = 200;
index_cnt=1;
% for k=1:time
%     EBU1_1min(k) =E_max*rand(1,1);
% end
% EBU1_PV_Output = EBU1_1min;
% unit of data is MB, distance is m
% for gamma = 0.5:0.75:1
UE_distance = 100*rand(nUE,1)+50*ones(nUE,1); % 50m
for k=72979:102979

  
    EBU1_1min(index_cnt) = EBU1(k);
    index_cnt = index_cnt+1;
end
EBU1_PV_Output = 10*0.05*0.75*EBU1_1min';
mean(EBU1_PV_Output)

% for plot

UE1_buffer_spar = zeros(time,2);
UE2_buffer_spar = zeros(time,2);
UE1_delta = zeros(time,2);
UE2_delta = zeros(time,2);
iteration = 8;
%
mean_delta = zeros(nUE,iteration);
for iter = 1:9
P_min = 35;
P_max = 140;
user_weight = 1;
c_effi = 0.8; % charging efficiency
s_effi = 0.99; % storage efficiency
bat_capacity = 250; %100 WHr
penalty = 30*iter;
theta_bat = penalty+ (P_max)/s_effi;

UE_buffermax = 500*ones(nUE); %500M 

macro_power = 5.2;
noise = -105.86;
carrier_num = 10;
delta_max = 10; % the max buffer consumption rate is 10M
UE_theta = user_weight*penalty + delta_max;

radius = 1000;%1km
grid = zeros(time,1); % grid power consumption
discharge = zeros(time,1);
cost = zeros(time,1);
BS_Power = zeros(time,1);
utility = zeros(nUE,time);
delta = zeros(nUE,time);

UE_SINR = zeros(nUE,carrier_num);
UE_avg_SINR = zeros(nUE,1);
UE_rate = zeros(nUE,carrier_num);
UE_rate_queue= zeros(nUE,carrier_num);
UE_buffer = zeros(nUE,time);
battery = zeros(time,1);

for nUE_loop = 1 :nUE % initialization
        UE_buffer(nUE_loop,1) = 100;
        for k = 1: carrier_num
            UE_SINR (nUE_loop,k) = 0;
            UE_rate (nUE_loop,k) = 0;
        end
        UE_avg_SINR(nUE_loop) = 10^(0.1*(macro_power - noise - 140.1 - 36.7 * log10(UE_distance(nUE_loop)/radius )));
end
tic
for t = 1:time
    
    charge = 0; 

% new user initializtion
    if t>1
        battery(t,:) = battery(t-1);         
    end
    battery_queue = battery(t) - theta_bat;
    

    for nUE_loop = 1 :nUE
         if t>1
            UE_buffer(nUE_loop,t) = UE_buffer(nUE_loop,t-1);
         end

        for k = 1: carrier_num

            UE_SINR (nUE_loop,k)  = exprnd(UE_avg_SINR(nUE_loop));
            UE_rate(nUE_loop,k) = log2(1+UE_SINR(nUE_loop,k))*10/carrier_num ;
           % pathloss = 128.1 + 37.6 log10(R)dB (R [km])
        end
    end
     UE_buffer_queue = UE_buffer(:,t) - UE_theta*ones(nUE,1);

%charge/discharge decision
     use_bat = 1; 
     if  battery_queue >= -penalty/c_effi
            use_bat = 1;
     
        if battery_queue <= -penalty 
            use_bat = 0;        
        end
     else

         use_bat = -1;    
     end

% decide buffer consumption rate
    for nUE_loop = 1 :nUE
        if UE_buffer_queue(nUE_loop) <= -user_weight*penalty/(1+delta_max)
            delta(nUE_loop,t)= -user_weight*penalty/UE_buffer_queue(nUE_loop)-1;
            utility(nUE_loop,t) = log(1+delta(nUE_loop,t));
        else
            delta(nUE_loop,t) = delta_max;
            utility(nUE_loop,t) = log(1+delta(nUE_loop,t));
        end
    end
% subcarrier allocation
switch use_bat
    case 1;
        threshold = 10.5*battery_queue/carrier_num ;
    case 0
        threshold = -10.5*penalty/carrier_num ;
    case -1
        threshold =  -10.5*penalty/carrier_num ;
end

   for k = 1: carrier_num
    UE_rate_queue(:,k) = UE_rate(:,k).*UE_buffer_queue;

   end
   active_num =0;
   for k = 1: carrier_num
     [min_rate_queue(k),index] = min(UE_rate_queue(:,k));
       if min_rate_queue(k) < threshold
            active_num  = active_num +1;
            UE_buffer(index,t) = UE_buffer(index,t) + UE_rate(index,k);
          
        end
    end
% update the buffer with consumption 

    UE_buffer(:,t) = UE_buffer(:,t) - delta(:,t);

 % calculate the power consumption
    
BS_Power(t) = P_min + (P_max-P_min)*active_num/carrier_num;
switch use_bat
    case 1
        battery(t) = min(battery(t)*s_effi - max(BS_Power(t)-EBU1_PV_Output(t)),bat_capacity) ;
  %      discharge(t) =  BS_Power(t)-EBU1_PV_Output(t);
        grid(t) =max(BS_Power(t)-EBU1_PV_Output(t)-bat_capacity*s_effi,0);;
    case 0 
        battery(t) = min(battery(t) *s_effi+max(0,EBU1_PV_Output(t)-BS_Power(t))*c_effi,bat_capacity);
        grid(t) =max(0,BS_Power(t) - EBU1_PV_Output(t));
    case -1
        battery(t) = battery(t) *s_effi + EBU1_PV_Output(t)*c_effi ;
        grid(t) =BS_Power(t);
%         grid(t) =max(BS_Power(t)-EBU1_PV_Output(t),0);
end
cost(t) = grid(t) -user_weight* sum(utility(:,t));
agg_utility(t) = sum(utility(:,t));

end
toc


% x=zeros(1,time);
% fig1 = figure
% box on
% plot(grid2);
% hold on
% plot(grid,'r');
% order=[2 1];
% plot(x,'--k');
% 
% xlabel('Time(Hr)','FontSize',14,'fontWeight','bold')
% ylabel('Surplus/Deficit Solar Power(W)')
% label= {'HTTP-D(battery)','our method'};
% legend(label);
% set(findall(fig1, '-property', 'FontSize'), 'FontSize', 14, 'fontWeight', 'bold')
% 
% fig3 = figure 
% hold on 
% plot( avg_buffer2);
% plot( sum(UE.buffer)'./act_num,'r');
% label= {'HTTP-D','SPAR'};
% legend(label)
% xlabel('Time(Hr)','FontSize',14)
% ylabel('Average Buffer(MB)')
% set(findall(fig3, '-property', 'FontSize'), 'FontSize', 14, 'fontWeight', 'bold')
% avg_buffer = sum(UE.buffer)'./act_num;
% % avg_buffer=avg_buffer(1201:30000);
% mean(BS_Power)
% mean(BS_Power2)
% mean(waste)
% mean(waste2)
% mean(grid)
% mean(grid2)
% mean(EBU1_PV_Output(1201:30000))
% 
% figure
% plot(battery_capacity)
% xlabel('Time(Hr)','FontSize',14,'fontWeight','bold')
% ylabel('Battery Capacity(Wh)')



mean_delta(:,iter) = mean (delta,2);



UE1_buffer_spar_trace(:,iter) = UE_buffer(1,:);
UE2_buffer_spar_trace(:,iter) = UE_buffer(2,:);
UE1_delta_trace(:,iter) = delta(1,:);
UE2_delta_trace(:,iter) = delta(2,:);
buffer_spar_max_trace(iter) = max(max(UE_buffer));
battery_spar_max_trace(iter) = max(battery);
buffer_spar_trace (iter) = mean(mean(UE_buffer,2))
battery_spar_trace(iter) = mean(battery)
cost_spar_trace(iter) = mean(cost)
BSpower_spar_trace(iter) = mean(BS_Power);
grid_spar_trace(iter) = mean(grid)
util_spar_trace(iter) = mean(agg_utility)
save('spar_trace.mat','battery_spar_trace','cost_spar_trace','buffer_spar_trace','buffer_spar_max_trace','battery_spar_max_trace','grid_spar_trace','util_spar_trace');
save('data2.mat','mean_delta');
end




